---@meta

---@class ARGFirstPersonCharacter : ACharacter
---@field BonesToReplicate TArray<FName>
---@field ReplicatedBoneState FReplicatedBoneState
---@field RagdollTransform FTransform
---@field VoiceLocationSocket FName
local ARGFirstPersonCharacter = {}

---@param EnableSwim boolean
function ARGFirstPersonCharacter:SetSwimEnabled(EnableSwim) end
---@param IsPlayerPassenger boolean
function ARGFirstPersonCharacter:SetIsPlayerPassenger(IsPlayerPassenger) end
---@param IsRagdolled boolean
function ARGFirstPersonCharacter:ReceiveSetRagdolled(IsRagdolled) end
---@return boolean
function ARGFirstPersonCharacter:ReceiveIsRagdolling() end
---@param AttachParent AActor
---@return boolean
function ARGFirstPersonCharacter:ReceiveCustomClientAttach(AttachParent) end
---@param PreviousReplicatedBoneState FReplicatedBoneState
function ARGFirstPersonCharacter:OnRep_ReplicatedBoneState(PreviousReplicatedBoneState) end
---@param NewId FUniqueNetIdRepl
function ARGFirstPersonCharacter:K2_OnUniqueIdSet(NewId) end
---@return boolean
function ARGFirstPersonCharacter:IsRagdolling() end
---@return FTransform
function ARGFirstPersonCharacter:GetRagdollTransform() end


---@class ARGGameMode : AGameModeBase
local ARGGameMode = {}

---@param Player AController
function ARGGameMode:TryToForceSeatPlayer(Player) end
---@param CheckpointIndex int32
function ARGGameMode:RestartFromCheckpoint(CheckpointIndex) end
function ARGGameMode:OnPreSeamlessTravel() end
---@param NewPlayer AController
function ARGGameMode:OnFailedToRestartPlayer(NewPlayer) end
---@param String FString
---@param Options FString
function ARGGameMode:K2_InitGame(String, Options) end
---@param PlayerStart AActor
---@param Player AController
---@return boolean
function ARGGameMode:IsStartSpotFree(PlayerStart, Player) end
---@return boolean
function ARGGameMode:IsEditorGame() end
---@return ARGGameSession
function ARGGameMode:GetGameSession() end
---@param Player AController
---@param Location FVector
---@param Rotation FRotator
---@param out_Location FVector
---@return boolean
function ARGGameMode:FindTeleportSpot(Player, Location, Rotation, out_Location) end


---@class ARGGameSession : AGameSession
local ARGGameSession = {}

---@param Player APlayerState
---@param KickReason FText
function ARGGameSession:K2_KickPlayer(Player, KickReason) end
---@param joinOption EJoinOptions
---@return FString
function ARGGameSession:GetJoinOptionsString(joinOption) end


---@class ARGGameState : AGameStateBase
---@field JoinOptions EJoinOptions
---@field OnPlayerAdded FRGGameStateOnPlayerAdded
---@field OnPlayerRemoved FRGGameStateOnPlayerRemoved
---@field bIsFromLoad EUnknownBool
---@field bPlayerHasReceivedHUD boolean
local ARGGameState = {}

---@param bHasReceivedHUD boolean
function ARGGameState:SetPlayerHasReceivedHUD(bHasReceivedHUD) end
---@param NewJoinOptions EJoinOptions
function ARGGameState:SetJoinOptions(NewJoinOptions) end
---@param bInIsFromLoad boolean
function ARGGameState:SetIsFromLoad(bInIsFromLoad) end
---@return EUnknownBool
function ARGGameState:IsFromLoad() end
---@return EJoinOptions
function ARGGameState:GetJoinOptions() end


---@class ARGInteractableActor : AActor
---@field SignificanceComponent USignificanceComponent
local ARGInteractableActor = {}

---@param AttachParent AActor
---@param AttachComponent USceneComponent
---@param SocketName FName
---@return boolean
function ARGInteractableActor:ReceiveCustomClientAttach(AttachParent, AttachComponent, SocketName) end


---@class ARGPlayerController : APlayerController
---@field CurrentRichPresenceStack TArray<ARGRichPresenceVolume>
---@field SpectatedPlayer ARGFirstPersonCharacter
---@field PreviewVOIPAudioCaptureComponent UAudioCaptureComponent
local ARGPlayerController = {}

function ARGPlayerController:StopVOIPTalking() end
function ARGPlayerController:StopSpectating() end
function ARGPlayerController:STFU() end
function ARGPlayerController:StartVOIPTalking() end
---@param NextPlayer boolean
function ARGPlayerController:SpectateAnotherPlayer(NextPlayer) end
---@param bHideHud boolean
---@param bHideFPSMesh boolean
function ARGPlayerController:SetPumpiMode(bHideHud, bHideFPSMesh) end
function ARGPlayerController:ReturnToMainMenu() end
function ARGPlayerController:ReceiveStopSpectating() end
---@param PlayerToSpectate ARGFirstPersonCharacter
function ARGPlayerController:ReceiveSpectatePlayer(PlayerToSpectate) end
function ARGPlayerController:ReceiveExitVehicleOnPawnLeavingGame() end
function ARGPlayerController:OnPumpiModeUpdated() end
function ARGPlayerController:OnPreSeamlessClientTravel() end
---@return boolean
function ARGPlayerController:IsPumpiHUDMode() end
---@return boolean
function ARGPlayerController:IsPumpiFPSMeshMode() end
---@return boolean
function ARGPlayerController:IsMenuController() end
---@return ARGFirstPersonCharacter
function ARGPlayerController:GetSpectatedPlayer() end
---@param Out_RichPresenceKey FString
---@return boolean
function ARGPlayerController:GetPresenceStringFromVolume(Out_RichPresenceKey) end
---@return FString
function ARGPlayerController:GetPresenceString() end
---@return FString
function ARGPlayerController:GetPresencePlayerStatus() end
---@return UAudioCaptureComponent
function ARGPlayerController:GetOrCreatePreviewVOIPAudioCaptureComponent() end
function ARGPlayerController:DestroyPreviewVOIPAudioComponent() end
function ARGPlayerController:DebugCrashInShipping() end
---@param Achievement TSoftObjectPtr<URGAchievement>
function ARGPlayerController:ClientUnlockAchievement(Achievement) end


---@class ARGPlayerState : APlayerState
local ARGPlayerState = {}

function ARGPlayerState:K2_OnSetUniqueId() end
---@return boolean
function ARGPlayerState:IsTalking() end


---@class ARGRichPresenceVolume : AVolume
---@field PresenceKey FString
---@field AcceptedActorClasses TArray<TSubclassOf<APawn>>
local ARGRichPresenceVolume = {}

---@return FString
function ARGRichPresenceVolume:GetPresenceKey() end


---@class ARGWinch : AActor
---@field TargetSpeed float
---@field FrontWinch boolean
---@field WinchRope ADynamicRopeActor
---@field WinchHook AActor
---@field WinchState FWinchState
---@field OtherWinch ARGWinch
---@field ForceAppliedLastFrame float
local ARGWinch = {}

---@param newWinchHook AActor
function ARGWinch:SetWinchHook(newWinchHook) end
---@param inWinchIsActive boolean
---@param inWinchIsPulling boolean
---@param inWinchIsReleasing boolean
function ARGWinch:SetActiveState(inWinchIsActive, inWinchIsPulling, inWinchIsReleasing) end
function ARGWinch:ResetWinchRope() end
---@param InstigatingPlayer ARGFirstPersonCharacter
function ARGWinch:ResetWinchByPlayer(InstigatingPlayer) end
---@param InstigatingPlayer ARGFirstPersonCharacter
function ARGWinch:ReceiveResetWinchByPlayer(InstigatingPlayer) end
---@param PreviousWinchStruggle float
---@param CurrentWinchStruggle float
function ARGWinch:ReceiveOnWinchWinchStruggleUpdated(PreviousWinchStruggle, CurrentWinchStruggle) end
function ARGWinch:ReceiveOnWinchRopeLengthUpdatesStopped() end
function ARGWinch:ReceiveOnWinchRopeLengthUpdatesStarted() end
---@param PreviousLength float
---@param CurrentLength float
function ARGWinch:ReceiveOnWinchRopeLengthUpdated(PreviousLength, CurrentLength) end
---@param newWinchHook AActor
function ARGWinch:ReceiveOnWinchHookUpdated(newWinchHook) end
---@param WinchIsActive boolean
---@param WinchIsPulling boolean
---@param WinchIsReleasing boolean
function ARGWinch:ReceiveOnActiveStateUpdated(WinchIsActive, WinchIsPulling, WinchIsReleasing) end
---@param PreviousLength float
---@param CurrentLength float
function ARGWinch:OnRopeLengthUpdated(PreviousLength, CurrentLength) end
function ARGWinch:OnRep_WinchState() end
function ARGWinch:OnRep_WinchRope() end
function ARGWinch:OnRep_WinchHook() end
---@return boolean
function ARGWinch:IsUsingDynamicRope() end
---@return FVector
function ARGWinch:GetWinchTargetLocation() end
---@return ADynamicRopeActor
function ARGWinch:GetWinchRope() end
---@return AActor
function ARGWinch:GetWinchHook() end
---@return float
function ARGWinch:GetForceAppliedLastFrame() end
---@param outWinchIsActive boolean
---@param outWinchIsPulling boolean
---@param outWinchIsReleasing boolean
function ARGWinch:GetActiveState(outWinchIsActive, outWinchIsPulling, outWinchIsReleasing) end


---@class ARGWorldSettings : AWorldSettings
---@field bEnableForceSeatZ boolean
---@field ForceSeatZ float
local ARGWorldSettings = {}

---@return boolean
function ARGWorldSettings:IsForceSeatZEnabled() end
---@return float
function ARGWorldSettings:GetForceSeatZ() end


---@class FRGErrorSuppress
---@field SuppressesType TArray<ERGNetworkFailureType>
---@field SupressesExactErrors TArray<FRGNetworkFailureMessage>
local FRGErrorSuppress = {}



---@class FRGFriendInfo
---@field DisplayName FString
---@field OnlineState ERGOnlinePresenceState
---@field UniqueNetId FUniqueNetIdRepl
---@field bIsPlayingSameGame boolean
---@field bIsJoinable boolean
local FRGFriendInfo = {}



---@class FRGNetworkFailureMessage
---@field NetworkFailureType ENetworkFailure::Type
---@field TravelFailureType ETravelFailure::Type
---@field CustomFailure FGameplayTag
---@field ErrorString FText
---@field MessageFailureType ERGNetworkFailureType
local FRGNetworkFailureMessage = {}



---@class FReplicatedBoneState
---@field BoneNames TArray<FName>
---@field BoneLocations TArray<FVector_NetQuantize>
---@field BoneRotations TArray<FQuat>
local FReplicatedBoneState = {}



---@class FTagFloatPair
---@field Tag FGameplayTag
---@field Value float
local FTagFloatPair = {}



---@class FTagIntPair
---@field Tag FGameplayTag
---@field Value int32
local FTagIntPair = {}



---@class FWinchState
---@field WinchIsActive boolean
---@field WinchIsPulling boolean
---@field WinchIsReleasing boolean
local FWinchState = {}



---@class IRGControllerInterface : IInterface
local IRGControllerInterface = {}

---@param ActivatableWidgetClass TSubclassOf<UCommonActivatableWidget>
---@param LayerID FGameplayTag
---@param InitDelegate FPushRGWidgetWithInitInitDelegate
function IRGControllerInterface:PushRGWidgetWithInit(ActivatableWidgetClass, LayerID, InitDelegate) end
---@param ActivatableWidgetClass TSubclassOf<UCommonActivatableWidget>
---@param LayerID FGameplayTag
function IRGControllerInterface:PushRGWdget(ActivatableWidgetClass, LayerID) end
---@param LayerID FGameplayTag
function IRGControllerInterface:PopRGWidget(LayerID) end


---@class IRGStaticSaveInterface : IInterface
local IRGStaticSaveInterface = {}

---@param SaveGameObject URGSaveGame
function IRGStaticSaveInterface:StaticSave(SaveGameObject) end
---@param SaveGameObject URGSaveGame
function IRGStaticSaveInterface:StaticLoad(SaveGameObject) end


---@class IRGVoiceSourceInterface : IInterface
local IRGVoiceSourceInterface = {}

---@param OutLocation FVector
---@param OutRotation FRotator
function IRGVoiceSourceInterface:GetVoiceLocation(OutLocation, OutRotation) end


---@class IRGWinchInterface : IInterface
local IRGWinchInterface = {}

---@param outCustomAttachLocation FVector
---@return boolean
function IRGWinchInterface:GetCustomAttachLocation(outCustomAttachLocation) end
---@return boolean
function IRGWinchInterface:AllowWinchAttach() end


---@class UGameplayTagMapLibrary : UBlueprintFunctionLibrary
local UGameplayTagMapLibrary = {}

---@param Map TArray<FTagIntPair>
---@param out_tags TArray<FGameplayTag>
---@param out_values TArray<int32>
function UGameplayTagMapLibrary:ToArrays_Int(Map, out_tags, out_values) end
---@param Map TArray<FTagFloatPair>
---@param out_tags TArray<FGameplayTag>
---@param out_values TArray<float>
function UGameplayTagMapLibrary:ToArrays_Float(Map, out_tags, out_values) end
---@param Map TArray<FTagIntPair>
---@return int32
function UGameplayTagMapLibrary:SumUpValues_Int(Map) end
---@param Map TArray<FTagFloatPair>
---@return float
function UGameplayTagMapLibrary:SumUpValues_Float(Map) end
---@param Map TArray<FTagIntPair>
---@param Tag FGameplayTag
---@param exactMatch boolean
---@return int32
function UGameplayTagMapLibrary:SumUpTagValues_Int(Map, Tag, exactMatch) end
---@param Map TArray<FTagFloatPair>
---@param Tag FGameplayTag
---@param exactMatch boolean
---@return float
function UGameplayTagMapLibrary:SumUpTagValues_Float(Map, Tag, exactMatch) end
---@param Map TArray<FTagIntPair>
---@param Tag FGameplayTag
function UGameplayTagMapLibrary:RemoveTagValue_Int(Map, Tag) end
---@param Map TArray<FTagFloatPair>
---@param Tag FGameplayTag
function UGameplayTagMapLibrary:RemoveTagValue_Float(Map, Tag) end
---@param Map TArray<FTagIntPair>
---@param Tag FGameplayTag
---@param out_value int32
---@return boolean
function UGameplayTagMapLibrary:FindTagValue_Int(Map, Tag, out_value) end
---@param Map TArray<FTagFloatPair>
---@param Tag FGameplayTag
---@param out_value float
---@return boolean
function UGameplayTagMapLibrary:FindTagValue_Float(Map, Tag, out_value) end
---@param Map TArray<FTagIntPair>
---@param Tag FGameplayTag
---@return boolean
function UGameplayTagMapLibrary:ContainsTagValue_Int(Map, Tag) end
---@param Map TArray<FTagFloatPair>
---@param Tag FGameplayTag
---@return boolean
function UGameplayTagMapLibrary:ContainsTagValue_Float(Map, Tag) end
---@param Map TArray<FTagIntPair>
---@param Tag FGameplayTag
---@param Value int32
function UGameplayTagMapLibrary:AddTagValue_Int(Map, Tag, Value) end
---@param Map TArray<FTagFloatPair>
---@param Tag FGameplayTag
---@param Value float
function UGameplayTagMapLibrary:AddTagValue_Float(Map, Tag, Value) end


---@class URGAchievement : UDataAsset
---@field ID FString
local URGAchievement = {}

---@return FString
function URGAchievement:GetId() end


---@class URGAchievementOneShot : URGAchievement
local URGAchievementOneShot = {}


---@class URGAchievementStat : URGAchievement
---@field StatName FString
---@field UnlockValue int32
---@field MaxValue int32
---@field bTriggerUINotify boolean
---@field NotifyStep int32
local URGAchievementStat = {}



---@class URGAchievementStatics : UBlueprintFunctionLibrary
local URGAchievementStatics = {}

---@param PC APlayerController
---@param Achievement TSoftObjectPtr<URGAchievement>
function URGAchievementStatics:UnlockAchievementForPC(PC, Achievement) end
---@param LocalPlayer ULocalPlayer
---@param Achievement TSoftObjectPtr<URGAchievement>
function URGAchievementStatics:UnlockAchievement(LocalPlayer, Achievement) end
---@param PC APlayerController
---@param Achievement TSoftObjectPtr<URGAchievementStat>
function URGAchievementStatics:IncrementAchivementForPC(PC, Achievement) end
---@param LocalPlayer ULocalPlayer
---@param Achievement TSoftObjectPtr<URGAchievementStat>
function URGAchievementStatics:IncrementAchivement(LocalPlayer, Achievement) end
---@param WorldContextObject UObject
---@param Achievement TSoftObjectPtr<URGAchievement>
function URGAchievementStatics:BroadcastAchievementUnlocked(WorldContextObject, Achievement) end


---@class URGAchivementSubsystem : ULocalPlayerSubsystem
---@field bHasInitialized boolean
local URGAchivementSubsystem = {}

---@param Achievement URGAchievement
function URGAchivementSubsystem:UnlockAchievement(Achievement) end
---@return ARGPlayerController
function URGAchivementSubsystem:GetPlayerController() end
---@return URGLocalPlayer
function URGAchivementSubsystem:GetLocalPlayer() end


---@class URGActivatableWidget : UCommonActivatableWidget
---@field ShouldRerouteMoveInput boolean
---@field BlockToggleMenuWithGamepad boolean
---@field EnhancedToggleMenuAction UInputAction
---@field EnhancedExtraAction UInputAction
local URGActivatableWidget = {}

---@param Widget UWidget
function URGActivatableWidget:UnregisterForScroll(Widget) end
---@param toggleAction UInputAction
function URGActivatableWidget:SetToggleMenuAction(toggleAction) end
---@param Widget UWidget
function URGActivatableWidget:RegisterForScroll(Widget) end
function URGActivatableWidget:HandleToggleMenuAction() end
function URGActivatableWidget:ClearEnhancedInputBindings() end
---@return boolean
function URGActivatableWidget:BP_HandleToggleMenuAction() end
---@param EnhancedInputAction UInputAction
---@param functionDelegate FBindEnhancedInputActionFunctionDelegate
---@param displayInActionBar boolean
function URGActivatableWidget:BindEnhancedInputAction(EnhancedInputAction, functionDelegate, displayInActionBar) end


---@class URGCharacterMovementComponent : UCharacterMovementComponent
local URGCharacterMovementComponent = {}


---@class URGCheatManager : UCheatManager
local URGCheatManager = {}

---@param PresenceText FString
function URGCheatManager:UpdatePresence(PresenceText) end
---@param bEnable boolean
function URGCheatManager:GodVehicles(bEnable) end
---@param bEnable boolean
function URGCheatManager:GodPlayers(bEnable) end


---@class URGCreateSessionCallbackProxy : UOnlineBlueprintCallProxyBase
---@field OnSuccess FRGCreateSessionCallbackProxyOnSuccess
---@field OnFailure FRGCreateSessionCallbackProxyOnFailure
local URGCreateSessionCallbackProxy = {}

---@param WorldContextObject UObject
---@param PlayerController APlayerController
---@param PrivateConnections int32
---@param bUseLobbiesIfAvailable boolean
---@return URGCreateSessionCallbackProxy
function URGCreateSessionCallbackProxy:CreateRideSession(WorldContextObject, PlayerController, PrivateConnections, bUseLobbiesIfAvailable) end


---@class URGDeveloperSettings : UDeveloperSettings
---@field ClassesToDestroyOnTravel TArray<TSoftClassPtr<AActor>>
---@field AchivementSubsystemClass TSubclassOf<URGAchivementSubsystem>
local URGDeveloperSettings = {}



---@class URGForceSeatComponent : USceneComponent
local URGForceSeatComponent = {}

---@param OverlappedComponent UPrimitiveComponent
---@param OtherActor AActor
---@param OtherComp UPrimitiveComponent
---@param OtherBodyIndex int32
---@param bFromSweep boolean
---@param SweepResult FHitResult
function URGForceSeatComponent:OnComponentBeginOverlap(OverlappedComponent, OtherActor, OtherComp, OtherBodyIndex, bFromSweep, SweepResult) end


---@class URGFunctionLibrary : UBlueprintFunctionLibrary
local URGFunctionLibrary = {}

---@param NewBatchMode EPSOBatchMode
function URGFunctionLibrary:SetPSOBatchMode(NewBatchMode) end
---@param Context UObject
function URGFunctionLibrary:RefreshWidgetRestorationTarget(Context) end
---@param PC APlayerController
---@return boolean
function URGFunctionLibrary:IsUsingGamepad(PC) end
---@return boolean
function URGFunctionLibrary:IsStartingFromCameraLocation() end
---@param A TMap<FName, UInputAction>
---@param B TMap<FName, UInputAction>
---@return boolean
function URGFunctionLibrary:IsPlayerInteractionsEqual(A, B) end
---@param TotalEntries int32
---@param EntriesLeft int32
function URGFunctionLibrary:GetPSOCompilationStatus(TotalEntries, EntriesLeft) end
---@return FString
function URGFunctionLibrary:GetOnlineNickname() end
---@param outMajor int32
---@param outMinor int32
---@param outPatch int32
---@param outCL int32
function URGFunctionLibrary:GetGameVersion(outMajor, outMinor, outPatch, outCL) end
---@return boolean
function URGFunctionLibrary:Build_WithEditor() end
---@param A TMap<UInputAction, FText>
---@param B TMap<UInputAction, FText>
---@return boolean
function URGFunctionLibrary:ArePlayerInteractionsEqual(A, B) end


---@class URGGameInstance : UGameInstance
---@field OnSessionUserInviteAccepted FRGGameInstanceOnSessionUserInviteAccepted
---@field OnJoinSessionCompleted FRGGameInstanceOnJoinSessionCompleted
local URGGameInstance = {}

---@param NewPlayer ULocalPlayer
---@param PIEInstance int32
function URGGameInstance:CreateOrLoadPlayerSaveGame(NewPlayer, PIEInstance) end
function URGGameInstance:ApplySoundSettings() end


---@class URGGameSessionSettings : UGameSessionSettings
local URGGameSessionSettings = {}


---@class URGGameUserSettings : UGameUserSettings
---@field bHasAutodetectedDLSS boolean
---@field SoundMasterVolume float
---@field SoundAmbientVolume float
---@field SoundMusicVolume float
---@field SoundEffectsVolume float
---@field SoundUIVolume float
---@field SoundVOIPVolume float
---@field NumAutosaveSlots int32
---@field AutosaveIntervalMinutes int32
---@field DepthOfFieldEnabled boolean
---@field aaMethod int32
---@field DidSetupFirstTime boolean
---@field bDLSSEnabled boolean
---@field bDLSSRREnabled boolean
---@field DLSSMode UDLSSMode
---@field MaxFPS int32
---@field bLumenEnabled boolean
---@field bHeadBobEnabled boolean
---@field FOV int32
---@field VOIPMode EVOIPMode
---@field SilenceDetectionAttackTime float
---@field SilenceDetectionReleaseTime float
---@field SilenceDetectionThreshold float
---@field MicInputGain float
---@field JitterBufferDelay float
---@field MicNoiseGateThreshold float
---@field MicNoiseAttackTime float
---@field MicNoiseReleaseTime float
---@field MouseSensitivity FVector2D
---@field ClutchSensitivity FVector2D
---@field bInvertLook boolean
local URGGameUserSettings = {}

---@param Mode EVOIPMode
function URGGameUserSettings:SetVOIPMode(Mode) end
---@param Volume float
function URGGameUserSettings:SetSoundVOIPVolume(Volume) end
---@param Volume float
function URGGameUserSettings:SetSoundUIVolume(Volume) end
---@param Volume float
function URGGameUserSettings:SetSoundMusicVolume(Volume) end
---@param Volume float
function URGGameUserSettings:SetSoundMasterVolume(Volume) end
---@param Volume float
function URGGameUserSettings:SetSoundEffectsVolume(Volume) end
---@param Volume float
function URGGameUserSettings:SetSoundAmbientVolume(Volume) end
---@param InSilenceDetectionThreshold float
function URGGameUserSettings:SetSilenceDetectionThreshold(InSilenceDetectionThreshold) end
---@param InSilenceDetectionReleaseTime float
function URGGameUserSettings:SetSilenceDetectionReleaseTime(InSilenceDetectionReleaseTime) end
---@param InSilenceDetectionAttackTime float
function URGGameUserSettings:SetSilenceDetectionAttackTime(InSilenceDetectionAttackTime) end
---@param SensitivityX float
---@param SensitivityY float
function URGGameUserSettings:SetMouseSensitivity(SensitivityX, SensitivityY) end
---@param InMicNoiseReleaseTime float
function URGGameUserSettings:SetMicNoiseReleaseTime(InMicNoiseReleaseTime) end
---@param InMicNoiseGateThreshold float
function URGGameUserSettings:SetMicNoiseGateThreshold(InMicNoiseGateThreshold) end
---@param InMicNoiseAttackTime float
function URGGameUserSettings:SetMicNoiseAttackTime(InMicNoiseAttackTime) end
---@param InMicInputGain float
function URGGameUserSettings:SetMicInputGain(InMicInputGain) end
---@param InMaxFPS int32
function URGGameUserSettings:SetMaxFPS(InMaxFPS) end
---@param InLumenEnabled boolean
function URGGameUserSettings:SetLumenEnabled(InLumenEnabled) end
---@param InJitterBufferDelay float
function URGGameUserSettings:SetJitterBufferDelay(InJitterBufferDelay) end
---@param bInvert boolean
function URGGameUserSettings:SetInvertLook(bInvert) end
---@param InHeadBobEnabled boolean
function URGGameUserSettings:SetHeadBobEnabled(InHeadBobEnabled) end
---@param InFOV int32
function URGGameUserSettings:SetFOV(InFOV) end
---@param bEnabled boolean
function URGGameUserSettings:SetDLSSRRModeEnabled(bEnabled) end
---@param bEnabled boolean
function URGGameUserSettings:SetDLSSModeEnabled(bEnabled) end
---@param Mode UDLSSMode
function URGGameUserSettings:SetDLSSMode(Mode) end
---@param Enabled boolean
function URGGameUserSettings:SetDepthOfFieldEnabled(Enabled) end
---@param SensitivityX float
---@param SensitivityY float
function URGGameUserSettings:SetClutchSensitivity(SensitivityX, SensitivityY) end
---@param aaMethod int32
function URGGameUserSettings:SetAAMethod(aaMethod) end
---@return boolean
function URGGameUserSettings:IsDLSSRREnabled() end
---@return boolean
function URGGameUserSettings:IsDLSSModeEnabled() end
---@return boolean
function URGGameUserSettings:IsDepthOfFieldEnabled() end
---@return EVOIPMode
function URGGameUserSettings:GetVOIPMode() end
---@return float
function URGGameUserSettings:GetSoundVOIPVolume() end
---@return float
function URGGameUserSettings:GetSoundUIVolume() end
---@return float
function URGGameUserSettings:GetSoundMusicVolume() end
---@return float
function URGGameUserSettings:GetSoundMasterVolume() end
---@return float
function URGGameUserSettings:GetSoundEffectsVolume() end
---@return float
function URGGameUserSettings:GetSoundAmbientVolume() end
---@return float
function URGGameUserSettings:GetSilenceDetectionThreshold() end
---@return float
function URGGameUserSettings:GetSilenceDetectionReleaseTime() end
---@return float
function URGGameUserSettings:GetSilenceDetectionAttackTime() end
---@return FVector2D
function URGGameUserSettings:GetMouseSensitivity() end
---@return float
function URGGameUserSettings:GetMicNoiseReleaseTime() end
---@return float
function URGGameUserSettings:GetMicNoiseGateThreshold() end
---@return float
function URGGameUserSettings:GetMicNoiseAttackTime() end
---@return float
function URGGameUserSettings:GetMicInputGain() end
---@return int32
function URGGameUserSettings:GetMaxFPS() end
---@return boolean
function URGGameUserSettings:GetLumenEnabled() end
---@return float
function URGGameUserSettings:GetJitterBufferDelay() end
---@return boolean
function URGGameUserSettings:GetInvertLook() end
---@return boolean
function URGGameUserSettings:GetHeadBobEnabled() end
---@return int32
function URGGameUserSettings:GetFOV() end
---@return UDLSSMode
function URGGameUserSettings:GetDLSSMode() end
---@return FVector2D
function URGGameUserSettings:GetClutchSensitivity() end
---@return int32
function URGGameUserSettings:GetAAMethodFromConfig() end
---@return int32
function URGGameUserSettings:GetAAMethod() end
function URGGameUserSettings:ApplyConsoleVarSettings() end


---@class URGGameViewportClient : UCommonGameViewportClient
---@field PendingNetworkFailureMessages TArray<FRGNetworkFailureMessage>
local URGGameViewportClient = {}

---@param Message FRGNetworkFailureMessage
---@return boolean
function URGGameViewportClient:ShouldAddNetworkFailure(Message) end
---@param OutMessage FRGNetworkFailureMessage
---@return boolean
function URGGameViewportClient:PopNextPendingNetworkFailureMessage(OutMessage) end
---@param OutMessage FRGNetworkFailureMessage
---@return boolean
function URGGameViewportClient:PeekNextPendingNetworkFailureMessage(OutMessage) end
function URGGameViewportClient:MergeNetworkFailureMessages() end
---@return boolean
function URGGameViewportClient:HasPendingNetworkFailureMessages() end
---@param WorldContextObject UObject
---@return URGGameViewportClient
function URGGameViewportClient:GetGameViewportClient(WorldContextObject) end
---@param ErrorId FGameplayTag
---@param ErrorString FText
function URGGameViewportClient:AddCustomErrorPopup(ErrorId, ErrorString) end


---@class URGGearBox : UActorComponent
---@field OnGearShifted FRGGearBoxOnGearShifted
---@field OnGearShifterPositionUpdated FRGGearBoxOnGearShifterPositionUpdated
---@field OnGearBoxStruggleUpdated FRGGearBoxOnGearBoxStruggleUpdated
---@field CurrentGear int32
---@field bIsClutchDown boolean
---@field GearShifterPosition_Display FVector2D
---@field NormalizedGearShifterStruggle FVector2D
---@field GearBoxTolerance float
---@field MinRegistrableMouseInput float
---@field MinRegistrableGamepadInput float
---@field GearBoxMouseInputMultiplier FVector2D
---@field GearBoxGamepadInputMultiplier FVector2D
---@field GearBoxMouseInputStruggleLimitsX FVector2D
---@field GearBoxMouseInputStruggleLimitsY FVector2D
---@field GearBoxMouseInputStruggleMultiplier FVector2D
---@field GearBoxMouseStruggleResetMultiplier FVector2D
---@field GearBoxGamepadInputStruggleLimitsX FVector2D
---@field GearBoxGamepadInputStruggleLimitsY FVector2D
---@field GearBoxGamepadInputStruggleMultiplier FVector2D
---@field GearBoxGamepadStruggleResetMultiplier FVector2D
---@field GearEngageYThreshold float
local URGGearBox = {}

---@param clutchDown boolean
function URGGearBox:SetClutchDown(clutchDown) end
---@param InGearShifterPosition_Display FVector2D
function URGGearBox:Server_SetGearShiftPosition_Display(InGearShifterPosition_Display) end
---@param InNormalizedGearShifterStruggle FVector2D
function URGGearBox:Server_SetGearShifterStruggle(InNormalizedGearShifterStruggle) end
---@param newGear int32
function URGGearBox:Server_SetCurrentGear(newGear) end
---@param PreviousNormalizedGearShifterStruggle FVector2D
function URGGearBox:OnRep_NormalizedGearShifterStruggle(PreviousNormalizedGearShifterStruggle) end
---@param previousGear int32
function URGGearBox:OnRep_CurrentGear(previousGear) end
---@return boolean
function URGGearBox:IsClutchDown() end
---@return FVector2D
function URGGearBox:GetGearShifterPosition_Debug() end
---@return FVector2D
function URGGearBox:GetGearShifterPosition() end
---@return int32
function URGGearBox:GetCurrentGear() end


---@class URGGetFriendsCallbackProxy : UOnlineBlueprintCallProxyBase
---@field OnSuccess FRGGetFriendsCallbackProxyOnSuccess
---@field OnFailure FRGGetFriendsCallbackProxyOnFailure
local URGGetFriendsCallbackProxy = {}

---@param WorldContextObject UObject
---@param PlayerController APlayerController
---@return URGGetFriendsCallbackProxy
function URGGetFriendsCallbackProxy:GetAndStoreFriendsList(WorldContextObject, PlayerController) end


---@class URGListEntryBase : UCommonButtonBase
local URGListEntryBase = {}

---@return UWidget
function URGListEntryBase:GetPrimaryGamepadFocusWidget() end


---@class URGListItemBase : URGListItemBaseNoText
---@field Text FText
local URGListItemBase = {}



---@class URGListItemBaseNoText : UObject
local URGListItemBaseNoText = {}

---@return TSubclassOf<URGListEntryBase>
function URGListItemBaseNoText:GetEntryClass() end


---@class URGListView : UCommonListView
local URGListView = {}

---@param Item UObject
function URGListView:BP_RequestNavigateToItem(Item) end


---@class URGLocalPlayer : ULocalPlayer
local URGLocalPlayer = {}

---@return ARGPlayerController
function URGLocalPlayer:GetRGPlayerController() end


---@class URGLocalizationSettings : UDeveloperSettings
---@field OnlineErrors TMap<FGameplayTag, FText>
local URGLocalizationSettings = {}

---@param Tag FGameplayTag
---@param OutLocalized FText
---@return boolean
function URGLocalizationSettings:GetOnlineErrorLocalisation(Tag, OutLocalized) end


---@class URGOnlineDeveloperSettings : UDeveloperSettings
---@field ErrorsSuppression TMap<FRGNetworkFailureMessage, FRGErrorSuppress>
---@field ServerSuppressedErrors TArray<ENetworkFailure::Type>
local URGOnlineDeveloperSettings = {}



---@class URGOnlineFunctionLibrary : UBlueprintFunctionLibrary
local URGOnlineFunctionLibrary = {}

---@return boolean
function URGOnlineFunctionLibrary:WasMicAboveNoiseGateThreshold() end
---@param FriendList TArray<FRGFriendInfo>
function URGOnlineFunctionLibrary:SortFriendList(FriendList) end
---@return boolean
function URGOnlineFunctionLibrary:ShowInviteUI() end
---@return boolean
function URGOnlineFunctionLibrary:ShowFriendsUI() end
---@param bEnabled boolean
function URGOnlineFunctionLibrary:SetLoopbackEnabled(bEnabled) end
---@return boolean
function URGOnlineFunctionLibrary:IsMicActive() end
---@return boolean
function URGOnlineFunctionLibrary:IsLoopbackEnabled() end
---@param VoiceCaptureComponent UAudioCaptureComponent
function URGOnlineFunctionLibrary:InitVoiceCaptureComponent(VoiceCaptureComponent) end
---@return ERGOnlineNicknameType
function URGOnlineFunctionLibrary:GetOnlineNicknameType() end
---@return FString
function URGOnlineFunctionLibrary:GetOnlineNickname() end
---@return float
function URGOnlineFunctionLibrary:GetInitialConnectionTimeout() end
---@param Message FRGNetworkFailureMessage
---@return FText
function URGOnlineFunctionLibrary:GetErrorHeadline(Message) end
---@param Message FRGNetworkFailureMessage
---@return FText
function URGOnlineFunctionLibrary:GetErrorDesc(Message) end
---@return float
function URGOnlineFunctionLibrary:GetConnectingTimeoutPassed() end


---@class URGOnlineSessionClient : UOnlineSessionClient
local URGOnlineSessionClient = {}


---@class URGPhysicsLibrary : UBlueprintFunctionLibrary
local URGPhysicsLibrary = {}

---@param Actor AActor
---@param PhysicsMesh UPrimitiveComponent
---@param TargetLocation FVector
---@param TargetRotation FRotator
---@param ActorsToIgnore TArray<AActor>
---@param ObjectTypesToBlock TArray<EObjectTypeQuery>
---@return boolean
function URGPhysicsLibrary:CanDropActorWithoutIntersecting(Actor, PhysicsMesh, TargetLocation, TargetRotation, ActorsToIgnore, ObjectTypesToBlock) end


---@class URGSaveGame : ULocalPlayerSaveGame
local URGSaveGame = {}

---@return ARGGameState
function URGSaveGame:GetGameState() end
---@return URGGameInstance
function URGSaveGame:GetGameInstance() end


---@class URGSaveHelpers : UBlueprintFunctionLibrary
local URGSaveHelpers = {}

---@param ActorClass TSubclassOf<AActor>
---@return UStaticMesh
function URGSaveHelpers:GetDefaultStaticMesh(ActorClass) end


---@class URGSaveStatics : UBlueprintFunctionLibrary
local URGSaveStatics = {}

---@param SaveGameClass TSubclassOf<ULocalPlayerSaveGame>
---@param LocalPlayer ULocalPlayer
---@param SlotName FString
---@return ULocalPlayerSaveGame
function URGSaveStatics:LoadOrCreateSaveGameForLocalPlayer(SaveGameClass, LocalPlayer, SlotName) end
---@return FString
function URGSaveStatics:GetRootSaveFolder() end
---@param WorldContextObject UObject
---@param ControllerId int32
---@return ULocalPlayer
function URGSaveStatics:GetLocalPlayerFromID(WorldContextObject, ControllerId) end
---@param SaveGameClass TSubclassOf<ULocalPlayerSaveGame>
---@param LocalPlayer ULocalPlayer
---@param SlotName FString
---@param Delegate FAsyncLoadOrCreateSaveGameForLocalPlayerDelegate
---@return boolean
function URGSaveStatics:AsyncLoadOrCreateSaveGameForLocalPlayer(SaveGameClass, LocalPlayer, SlotName, Delegate) end


---@class URGStartingPreferences : UDeveloperSettings
---@field StartingCheckpoint int32
---@field StartAsDriver EStartAsDriver
---@field GodMode EGodMode
---@field bNoSplash boolean
---@field bUseEditorSaveInPIE boolean
local URGStartingPreferences = {}

---@return URGStartingPreferences
function URGStartingPreferences:RGStartingPreferences() end
---@return int32
function URGStartingPreferences:GetStartingCheckpoint() end


---@class URGVOIPDebugSubsystem : ULocalPlayerSubsystem
local URGVOIPDebugSubsystem = {}


---@class URGVOIPTalker : UVOIPTalker
---@field CurrentAudioComponent UAudioComponent
local URGVOIPTalker = {}



---@class URGVehicleBumperCollision : UBoxComponent
---@field CachedOwningVehicle AVehicleSystemBase
local URGVehicleBumperCollision = {}

---@param OverlappedComponent UPrimitiveComponent
---@param OtherActor AActor
---@param OtherComp UPrimitiveComponent
---@param OtherBodyIndex int32
---@param bFromSweep boolean
---@param SweepResult FHitResult
function URGVehicleBumperCollision:OnBumperOverlapped(OverlappedComponent, OtherActor, OtherComp, OtherBodyIndex, bFromSweep, SweepResult) end


---@class URGWidgetStack : UCommonActivatableWidgetStack
local URGWidgetStack = {}

---@param ActivatableWidgetClass TSubclassOf<UCommonActivatableWidget>
---@param InitFunc FPushWidgetWithInitInitFunc
---@return UCommonActivatableWidget
function URGWidgetStack:PushWidgetWithInit(ActivatableWidgetClass, InitFunc) end


---@class URGWidgetSwitcher : UCommonActivatableWidgetSwitcher
---@field BP_OnActiveSwitcherIndexChangedDelegate FRGWidgetSwitcherBP_OnActiveSwitcherIndexChangedDelegate
local URGWidgetSwitcher = {}



